<template>
    <div class="wrapper">
        <md-toolbar class="md-dense md-red toolbar-heigth">
            <h3 class="ml-8 md-title text-align-left text-white">
                <md-icon class="text-white">list</md-icon>
                {{ title }}
            </h3>
        </md-toolbar>
        <div class="container">
            <loading :active.sync="loading" is-full-page></loading>
            <div class="md-layout md-alignment-top-center">
                <div class="md-layout-item md-size-50 md-small-size-100">
                    <md-steppers :md-active-step.sync="active" md-linear>
                        <md-step id="first" md-label="Informacion" :md-editable="editableBefore" :md-done.sync="first">
                            <div class="md-layout md-alignment-top-center">
                                <div class="md-layout-item">
                                    <form id="firstStep" novalidate>
                                        <md-field :class="getValidationClass('title')">
                                            <label>Título</label>
                                            <md-input v-model="step1Form.title" required></md-input>
                                            <span class="md-error">Ingrese un título</span>
                                        </md-field>
                                        <md-field :class="getValidationClass('categories')">
                                            <label for="categories">Categoría</label>
                                            <md-select v-model="step1Form.categories" required name="categories" id="categories" multiple>
                                                <md-option v-for="item in categories" v-bind:key="item.id" :value="item.id">
                                                    {{ item.label }}</md-option
                                                >
                                            </md-select>
                                            <div class="md-error" v-if="!$v.step1Form.categories.required">
                                                Selecciona una categoria.
                                            </div>
                                            <div class="md-error" v-if="!$v.step1Form.categories.maxLength">
                                                Máximo
                                                {{ $v.step1Form.categories.$params.maxLength.max }}
                                                categorías.
                                            </div>
                                        </md-field>
                                        <md-field :class="getValidationClass('video_url')">
                                            <label>Video URL</label>
                                            <md-input v-model="step1Form.video_url"></md-input>
                                            <span class="md-error">Ingrese una URL valida</span>
                                        </md-field>
                                        <!-- <md-field :class="getValidationClass('slug')">
                                        <label>Etiqueta</label>
                                        <md-select v-model="step1Form.slug" required name="tag" id="tag">
                                            <md-option v-for="item in tags" v-bind:key="item.id" :value="item.slug">
                                                {{ item.label }}</md-option>
                                        </md-select>
                                        <span class="md-error">Seleccione una etiqueta</span>
                                    </md-field> -->
                                    </form>
                                </div>
                            </div>
                            <md-button class="md-raised md-primary" @click="validateStep1">Continuar</md-button>
                            <!-- <md-button class="md-raised md-primary" @click="setDone('first', 'second')">Continuar</md-button> -->
                        </md-step>

                        <md-step id="second" md-label="Contenido" :md-editable="editableBefore" :md-error="secondStepError" :md-done.sync="second">
                            <div class="md-layout md-alignment-top-center">
                                <div class="md-layout-item">
                                    <form id="secondStep" novalidate>
                                        <md-field :class="getValidationClass2('content')">
                                            <label>Escribe un resumen</label>
                                            <md-textarea v-model="step2Form.content" required maxlength="300"></md-textarea>
                                            <span class="md-helper-text">Máximo 300 carácteres</span>
                                            <div class="md-error" v-if="!$v.step2Form.content.required">
                                                Ingrese un resumen.
                                            </div>
                                            <div class="md-error" v-if="!$v.step2Form.content.maxLength">
                                                Máximo
                                                {{ $v.step2Form.content.$params.maxLength.max }}
                                                carácteres.
                                            </div>
                                        </md-field>
                                        <br />
                                        <span>
                                            Subir un archivo. Formatos permitidos PDF, DOC, DOCX, PPT, PPTX, RTF, TXT con un peso máximo de 10mb</span
                                        >
                                        <md-field ref="single" md-inline :class="getValidationClass2('attachment')">
                                            <label>Da click aquí</label>
                                            <md-file
                                                v-model="single"
                                                @change="selectFile"
                                                accept=".pdf, .doc,.docx, .ppt, .pptx, .rtf, .txt"
                                                required
                                            />
                                            <span class="md-error">Seleccione un archivo</span>
                                            <!-- <span class="md-helper-text">Formatos permitidos PDF, DOC, DOCX, PPT, PPTX, RTF, TXT con un peso máximo de 10mb</span> -->
                                        </md-field>
                                        <p v-if="step1Form && step1Form.attachment && step1Form.attachment.includes('.') && attachment">
                                            Archivo cargado:
                                            <a href="#" @click="downloadFile(step1Form)">{{ this.attachment }}</a>
                                        </p>
                                    </form>
                                </div>
                            </div>
                            <md-button class="md-raised md-primary" @click="validateStep2">Publicar</md-button>
                            <!-- <md-button class="md-raised md-primary" @click="setError()">Set error!</md-button> -->
                        </md-step>

                        <md-step id="third" md-label="Publicado" :md-done.sync="third">
                            <h3>¡Gracias por compartir este recurso!</h3>
                            <p>
                                A la brevedad el equipo de ParaLideres publicará tu colaboración después de examinar su contenido,<br />enviendote un
                                email de confirmacion. Gracias de nuevo.
                            </p>
                            <md-button class="md-raised md-primary" to="/recursos">Ir a todos los recursos</md-button>
                        </md-step>
                    </md-steppers>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import axios from 'axios';
import { validationMixin } from 'vuelidate';
import { requiredUnless } from 'vuelidate/lib/validators';
import { required, requiredIf, minLength, maxLength, url, helpers } from 'vuelidate/lib/validators';
const alpha = helpers.regex('alpha', /^(?:https?:\/\/)?(?:www\.)?(?:youtu\.be\/|youtube\.com\/(?:embed\/|v\/|watch\?v=|watch\?.+&v=))((\w|-){11})?$/);

export default {
    name: 'resource',
    mixins: [validationMixin],
    data() {
        return {
            title: 'Crear recurso',
            single: null,
            limit: false,
            attachment: '',
            step1Form: {
                id: 0,
                title: null,
                categories: null,
                video_url: null,
                slug: null
            },
            step2Form: {
                content: null,
                attachment: null
            },
            endPoint: '/api/resource',
            categoriesEndPoint: '/api/categories',
            tagsEndPoint: '/api/tagsList',
            loading: false,
            categories: [],
            tags: [],
            resourceId: 0,
            isOptional: false,
            active: 'first',
            first: false,
            second: false,
            third: false,
            editableBefore: true,
            secondStepError: null
        };
    },
    validations: {
        step1Form: {
            title: {
                required,
                minLength: minLength(3)
            },
            categories: {
                required,
                minLength: minLength(1),
                maxLength: maxLength(2)
            },
            video_url: {
                url
                // alpha
            }
            // slug: {
            //     required,
            //     minLength: minLength(3),
            // },
        },
        step2Form: {
            content: {
                required,
                maxLength: maxLength(300)
            },
            attachment: {
                required: requiredIf(function(step2Form) {
                    return !this.isOptional;
                })
            }
        }
    },
    computed: {
        attachment() {
            if (this.step2Form.id > 0 && this.attachment) {
                return (isOptional = false);
            }
        }
    },
    watch: {
        single(val) {
            if (this.limit) {
                // debugger
                this.single = '-';
            }
        }
    },
    methods: {
        getValidationClass(fieldName) {
            const field = this.$v.step1Form[fieldName];

            if (field) {
                return {
                    'md-invalid': field.$invalid && field.$dirty
                };
            }
        },
        getValidationClass2(fieldName) {
            const field = this.$v.step2Form[fieldName];

            if (field) {
                return {
                    'md-invalid': field.$invalid && field.$dirty
                };
            }
        },
        clearForm() {
            this.$v.$reset();
            this.step1Form = {};
            this.step2Form = {};
        },
        validateStep1() {
            this.$v.step1Form.$touch();

            if (!this.$v.step1Form.$invalid) {
                this.setDone('first', 'second');
            }
        },
        validateStep2() {
            this.$v.step2Form.$touch();

            if (!this.$v.$invalid) {
                this.submitResource();
            }
        },
        submitResource() {
            let data = new FormData();
            this.loading = true;
            this.editableBefore = false; //Bloquea a que se pueda retornar a pasos anteriores

            data.append('id', this.step1Form.id);
            data.append('title', this.step1Form.title);
            data.append('categories', this.step1Form.categories);
            data.append('video_url', this.step1Form.video_url);
            data.append('slug', this.step1Form.slug);
            data.append('attachment', this.step2Form.attachment);
            data.append('content', this.step2Form.content);

            axios
                .post(this.endPoint, data)
                .then((res) => {
                    if (res && res.data) {
                        this.setDone('second', 'third');
                    } else {
                        this.$root.WarnMgs('Sin datos del servidor');
                    }
                })
                .catch((error) => {
                    this.$root.ErrorMgs('Error al publicar recurso');
                })
                .finally(() => {
                    this.loading = false;
                });
        },
        getResourceById() {
            let uri = `${this.endPoint}/${this.resourceId}`;
            this.loading = true;

            axios
                .get(uri)
                .then((res) => {
                    if (res && res.data && res.data && res.data.data) {
                        this.step1Form = Object.assign({}, res.data.data);
                        this.step1Form.categories = this.step1Form.categories.map((c) => c.id);
                        this.step2Form.content = res.data.data.content;
                        this.step2Form.attachment = res.data.data.local_attachment;
                        let archivo = res.data.data.attachment.split('/');
                        this.attachment = archivo[1];
                        this.updateMessages();
                    } else {
                        this.step1Form = {};
                        this.step2Form = {};
                    }
                })
                .catch((error) => {
                    this.$root.ErrorMgs('Error al obtener el recurso');
                    console.log('Error GetCategories' + error);
                })
                .finally(() => {
                    this.loading = false;
                });
        },
        getCategories() {
            axios
                .get(this.categoriesEndPoint)
                .then((res) => {
                    if (res && res.data && res.data.categories) {
                        this.categories = res.data.categories;
                    } else {
                        this.categories = [];
                    }
                })
                .catch((error) => {
                    this.$root.ErrorMgs('Error al obtener las categorías');
                    console.log('Error GetCategories' + error);
                });
        },
        getTags() {
            axios
                .get(this.tagsEndPoint)
                .then((res) => {
                    if (res && res.data) {
                        this.tags = res.data;
                    } else {
                        this.tags = [];
                    }
                })
                .catch((error) => {
                    this.$root.ErrorMgs('Error al obtener las etiquetas');
                    console.log('Error GetCategories' + error);
                });
        },
        selectFile(event) {
            // 1617418 80000000
            if (event.target.files[0].size > 80000000) {
                this.limit = true;
                this.$root.WarnMgs('El archivo es mayor a 10mb');
                this.single = '';
                // return;
            } else {
                // debugger
                let filePath = event.target.files[0].name.toLowerCase();
                //PDF, DOC, DOCX, PPT, PPTX, RTF, TXT
                let allowedExtensions = /(.pdf|.doc|.docx|.ppt|.pptx|.rtf|.txt)$/i;
                if (!allowedExtensions.exec(filePath)) {
                    this.$root.WarnMgs('Los formatos permitidos son PDF, DOC, DOCX, PPT, PPTX, RTF, TXT');
                    this.limit = true;
                    // this.single = NULL
                    // this.$refs.single.MdField.value.target.localName = null
                } else {
                    // `files` is always an array because the file input may be in multiple mode
                    this.step2Form.attachment = event.target.files[0];
                    this.attachment = null;
                    // event.target.files[0];
                }
            }
        },
        setDone(id, index) {
            this[id] = true;

            this.secondStepError = null;

            if (index) {
                this.active = index;
            }
        },
        setError() {
            this.secondStepError = 'This is an error!';
        },
        updateMessages() {
            this.title = 'Actualizar recursos';
        },
        downloadFile(resource) {
            let current = Object.assign({}, resource);
            let fileName = current.attachment.split('/')[1];
            const uri = `/api/file/${current.id}`;

            axios
                .get(uri, {
                    responseType: 'arraybuffer'
                })
                .then((res) => {
                    let blob = new Blob([res.data], {
                        type: 'application/*'
                    });
                    let link = document.createElement('a');
                    link.href = window.URL.createObjectURL(blob);
                    link.download = fileName;
                    link.click();
                });
        }
    },
    mounted() {
        this.getCategories();
        // this.getTags();
        this.resourceId = this.$route?.params?.id;

        if (this.resourceId) {
            this.getResourceById();
        }
    }
};
</script>
